unit FrmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Process, StdCtrls, Buttons;

type
  TFormMain = class(TForm)
    EditInputFile: TEdit;
    EditOutputFile: TEdit;
    SpeedButtonDoIt: TSpeedButton;
    SpeedButtonInputFile: TSpeedButton;
    SpeedButtonOutputFile: TSpeedButton;
    MemoFeedback: TMemo;
    SpeedButtonExit: TSpeedButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    procedure SpeedButtonInputFileClick(Sender: TObject);
    procedure SpeedButtonOutputFileClick(Sender: TObject);
    procedure SpeedButtonDoItClick(Sender: TObject);
    procedure SpeedButtonExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
      FInputFileName  : String;
      FOutputFileName : String;
    Procedure   SelectInputFile;
    Procedure   SelectOutputFile;
    Procedure   DoIt;
    Procedure   ShowFeedback( Const aMsg: String);

    Procedure   SetInputFileName ( Const aValue: String);
    Procedure   SetOutputFileName( Const aValue: String);

    Property    InputFileName  : String Read FInputFileName  Write SetInputFileName;
    Property    OutputFileName : String Read FOutputFileName Write SetOutputFileName;
  end;

var
  FormMain: TFormMain;

implementation

{$R *.DFM}

// User area

    Procedure   TFormMain.SelectInputFile;
    Begin
      With OpenDialog Do
      Begin
        FileName := InputFileName;
        If Execute
        Then InputFileName := FileName;
      End;
    End;

    Procedure   TFormMain.SelectOutputFile;
    Begin
      With SaveDialog Do
      Begin
        FileName := OutputFileName;
        If Execute
        Then OutputFileName := FileName;
      End;
    End;

    Procedure   TFormMain.DoIt;
    Begin
      MemoFeedback.Clear;
      DoStuff( InputFileName, OutputFileName, ShowFeedback);
    End;

    Procedure   TFormMain.ShowFeedback( Const aMsg: String);
    Begin
      MemoFeedBack.Lines.Append( aMsg);
    End;

    Procedure   TFormMain.SetInputFileName( Const aValue: String);
    Begin
      If aValue <> FInputFileName
      Then Begin
        FInputFileName := aValue;
        EditInputFile.Text := FInputFileName;
      End;
    End;

    Procedure   TFormMain.SetOutputFileName( Const aValue: String);
    Begin
      If aValue <> FOutputFileName
      Then Begin
        FOutputFileName := aValue;
        EditOutputFile.Text := FOutputFileName;
      End;
    End;



// Delphi area



procedure TFormMain.SpeedButtonInputFileClick(Sender: TObject);
begin
  SelectInputFile;
end;

procedure TFormMain.SpeedButtonOutputFileClick(Sender: TObject);
begin
  SelectOutputFile;
end;

procedure TFormMain.SpeedButtonDoItClick(Sender: TObject);
begin
  DoIt;
end;

procedure TFormMain.SpeedButtonExitClick(Sender: TObject);
begin
  Close;
end;

procedure TFormMain.FormCreate(Sender: TObject);
begin
  MemoFeedback  .Clear;
  EditInputFile .Text := '';
  EditOutputFile.Text := '';
  Caption := Format( '%s - %s', [ Caption, Version]);
end;

end.
