unit Globals;

interface

Uses

  SysUtils, Windows, Messages, StdCtrls, Forms, Dialogs;


{$DEFINE DEBUG}
{$UNDEF DEBUG}

Const

  WM_GRIDSELECTIONCHANGED = WM_USER + 0;

// Our name and path stuff

  Function  ApplicationPath     : String;
  Function  ApplicationPathURL  : String;
  Function  ApplicationFileName : String;
  Function  IniFileName         : String;
  Function  FileNameToURL( Const aFileName : String): String;
  Function  CleanFileName( Const aFileName : String): String;
  // Returns filename only, path and extension are stripped off.


// Miscellaneous

  Procedure NotImplemented( Const aMsg: String);
  Procedure Noop;



implementation


// Our name and path stuff

Var

  strApplicationPath     : String;
  strApplicationPathURL  : String;
  strApplicationFileName : String;
  strIniFileName         : String;

  Function ApplicationPath: String;
  Begin
    Result := strApplicationPath;
  End;

  Function ApplicationPathURL : String;
  Begin
    Result := strApplicationPathURL;
  End;

  Function ApplicationFileName: String;
  Begin
    Result := strApplicationFileName;
  End;

  Function IniFileName: String;
  Begin
    Result := strIniFileName;
  End;

  Function FileNameToURL( Const aFileName: String): String;
  Var
    i : Integer;
  Begin
    Result := aFileName;
    For i := 1 To Length( Result) Do
      Case Result[ i] Of
        ':' : Result[ i] := '|';
        '\' : Result[ i] := '/';
      End;
    Result := 'file:///' + Result;
  End;

  Procedure InitModule;
  Var
    S : String;
    p : Integer;
  Begin
    S := Application.ExeName;
    strApplicationFileName := ExtractFileName( S);
    strApplicationPath     := ExtractFilePath( S);
    strApplicationPathURL  := FileNameToURL( strApplicationPath);
    p := Pos( '.', strApplicationFileName);
    If p = 0
    Then strIniFileName := strApplicationPath + strApplicationFileName + '.INI'
    Else strIniFileName := strApplicationPath + Copy( strApplicationFileName, 0, p - 1) + '.INI';
  End;


  Function  CleanFileName( Const aFileName : String): String;
  Var
    i : Integer;
  Begin
    Result := ExtractFileName( aFileName);
    i := Pos( '.', Result);
    If i > 0
    Then Result := Copy( Result, 1, i - 1);
  End;



// Miscellaneous

  Procedure NotImplemented( Const aMsg: String);
  Begin
    MessageDlg(
      Format(
        'Not implemented : %s',
        [ aMsg]
      ),
      mtInformation,
      [ mbOk, mbCancel],
      0
    );
  End;

  Procedure Noop;
  Begin
  End;


Initialization

  InitModule;

Finalization

end.


